#!/usr/bin/perl
#
# tinyCMS content management system
# Copyright (C) 2000 by Andi Kuebler <andi.kuebler@t-online.de>
#
# This programm is free software; you can redistribute it and/or modify
# it under the terms of the GNU Public License as published by the Free
# Software Foundation; either version 2, or (at your opinion) any later
# version.
#
# This programm is distributed in the hope that it will be usefull,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this programm; if not, write to the Free Software
# Foundation, INC., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA

package tinyCMS;
use vars qw($dbp);
$VERSION = 0.2;

$tinyCMS::db    = config("db_dir").config("db_name");
$tinyCMS::pw    = config("db_dir").config("pw_db");
$tinyCMS::users = config("users");
$tinyCMS::cats  = config("db_dir").config("kat_db");

sub config {
    open(RC, "/etc/sasrc") || die $!;
    @rc = <RC>;
    close(RC);

    foreach (@rc) {
	unless (/^#/) {
		($x, $y) = split(/=/);
		chomp($y);
		$cf{$x} = $y;
	    }
    }
    $que = shift;
    $ret = $cf{$que};
    return $ret;
}
sub whole_article {
    ($zeile, $p) = @_;
    $fp = $tinyCMS::db;
    if ($p) { $fp = $p; }
    open(DB, $fp) || die $!;
    @db = <DB>;
    close(DB);
    $i = 0;
    READ: while ($db[$zeile] !~ /^$/) {
	$re[$i] = $db[$zeile];
	next READ;
    }
    continue {
	$zeile++;
	$i++;
    }
    return @re;
}
sub header {
    @head = @_[0..3];
    return @head;
}

sub entries {
    open(DB, $tinyCMS::db) || die $!;
    @db = <DB>;
    close(DB);

    for ($i = 0; $db[$i] !~ /<Kategorie>: /; $i++) {
	;
    }
    foreach (@db) {
	if (/<Kategorie>: /) {
	    $tmp1 = qq(<tr><td><a href=form.pl?zeile=);
	}
	if (/<Subject>: /) {
	    $_ =~ s/<.*?>: //g;
	    chomp($_);
	    $p = $j - (3+$i);
	    $pw = $tmp1.$p;
	    $an = qq(>$_</a></td><td>
	            <input type=checkbox name=line value=$p> Loeschen</td></tr>
		     );
	    $rpw = $pw.$an;
	    push(@re, $rpw);
	}
	$j++;
    }
    return @re;
}

sub check_passwd {
    $dbd = config("db_dir");
    $pwn = config("pw_db");
    open(PW, $dbd.$pwn) || die $!;
    @pws = <PW>;
    close(PW);
    ($un, $paw) = @_;
    foreach $line (@pws) {
	if ($line =~ $un) {
	    ($un, $pw, $k, $alias, $area) = split(/:/, $line);
	    chomp($area);
	    if ($pw eq (crypt($paw, $k))) {
		$state = 1;
	    }
	}
    }
    @re = ($state, $alias, $area);
    return @re;
}
sub get_kats {
    $daba = shift;
    open(DB, $daba) || die $!;
    @db = <DB>;
    close(DB);
    foreach (@db) {
	if (/<Kategorie>: /) {
	    chomp($_);
	    for ($_) { s/<Kategorie>: //g; }
	    @tmp = split(/\//);
	    pop(@tmp);
	    foreach (@tmp) { $path .= $_."/"; }
	    unless ($kat{$path}) {
		$kat{$path} = 1;
		$path = ();
	    }
	}
    }
    @kats = keys %kat;
    return @kats;
}
sub format_article {
    @art = @_;
    for (@art) { s/<.*?>: //g; }
    $re = qq(
	     <table width=100%>
<tr>
<td><center><h1>$art[3]</h1></center></td>
</tr>
<tr>
<td>
@art[4..$#art]
</td>
</tr>
<tr>
<td align=right>$art[0]</td>
</tr>
</table>
	     );

    return $re;
}
sub getcatbypath {
    $path=shift;
    $dbd = config("db_dir").config("kat_db");
    open(KDB, $dbd) || die $!;
    @in = <KDB>;
    close(KDB);
    foreach $l (@in) {
	@tmp = split(/:/, $l);
	$re{$tmp[0]} = $tmp[1];
    }
    return $re{$path};
}
sub getpathbycat {
    $arg = shift;
    $dbp = config("db_dir").config("kat_db");
    open(KDB, $dbp) || die $!;
    @in = <KDB>;
    close(KDB);
    foreach $line (@in) {
	@tmp = split(/:/, $line);
	$re{$tmp[1]} = $tmp[0];
    }
    return $re{$arg};
}
sub getsvlbypath {
    $arg = shift;
    open(KDB, $tinyCMS::cats) || die $!;
    @in = <KDB>;
    close(KDB);
    foreach (@in) {
	@tmp = split(/:/);
	$re{$tmp[0]} = $tmp[2];
    }
    return $re{$arg};
}
sub getaliasbynick {
    $nick = shift;
    open(PWF, $tinyCMS::pw) || die $!;
    @pwf = <PWF>;
    close(PWF);
    foreach (@pwf) {
	@tmp = split(/:/);
	if ($tmp[0] eq $nick) {
	    $re = $tmp[3];
	}
    }
    return $re;
}
sub usertable {
    open(USERS, $tinyCMS::pw) || die $!;
    @in = <USERS>;
    close(USERS);
    $th = qq(<tr><td><b>Login:</b></td><td><b>Alias:</b></td><td><b>Area:</b></td></tr>);
    push(@table, $th);
    foreach (@in) {
	@tmp = split(/:/);
	$td = qq(<tr>
	 <td>$tmp[0]</td>
	 <td>$tmp[3]</td>
	 <td>$tmp[4]</td>
	 </tr>
	 );
	push(@table, $td);
    }
    return @table;
}
sub basename {
    $re = shift;
    $re =~s/(.*\/).*/$1/g;
    return $re;
}
sub delentry {
    ($line, $file) = @_;
    $f = $tinyCMS::db;
    if ($file) { $f = $file; }
    @cli = whole_article($line, $f);
    open(MOD, $f) || die $!;
    @db = <MOD>;
    close(MOD);
    @fp = @db[0..$line-1];
    @sp = @db[$#fp+$#cli+3..$#db];

    if ($cli[0] =~/<Kategorie>: /) {
    open(MOD, ">$f") || die $!;
    print MOD @fp;
    print MOD @sp;
    close(MOD);
}
    else {
	die "Wrong line!";
    }
}
sub chkpwen {
    ($un, $pw) = @_;
    open(DB, "/home/andi/www/spohn/db/saspass") || die $!;
    @pws = <DB>;
    close(DB);
    foreach $li (@pws) {
	@line = split(/:/, $li);
	if ($line[0] =~ /$un/) {
	    if ($line[1] eq $pw) {
		$re = 1;
	    }
	    else {
		$re = 0;
	    }
	}
    }
    return $re;
}
	   
sub postmesg {
    $path = $tinyCMS::users."mailer/mesg_com";
    ($header, $body) = @_;
    open(MESG, ">>$path") || die $!;
    print MESG $header, "\n";
    print MESG $body, "\n\n";
    close(MESG);
}
sub get_mesg {
    ($c, $un, $pop) = @_;
    $ind = $c;

    open(MESG, $tinyCMS::users."mailer/mesg_com") || die $!;
    @mesg = <MESG>;
    close(MESG);

    while ($mesg[$c] =~ /^.*?: .*$/) {
	$mainmesg[$d] = $mesg[$c];
	$d++;
	$c++;
    }
    while (($mesg[$c] !~ /^.*?: .*$/) && ($c != $#mesg)) {
	$mainmesg[$d] = $mesg[$c];
	$d++;
	$c++;
    }
    if ($pop && $un) {
	open(MESG, ">".$tinyCMS::users."mailer/mesg_com") || die $!;

	@first_part = @mesg[0..$ind-1];
	@sec_part   = @mesg[$ind+$#mainmesg+1..$#mesg];

	print MESG @first_part;
	print MESG @sec_part;
	close(MESG);

	$pth = $tinyCMS::users.$un."/.messages";
	open(NEWMESG, ">>$pth") || die $!;
	print NEWMESG @mainmesg, "\n";
	close(NEWMESG);
    }
}
sub getcrpw {
    $un = shift;
    open(PWD, config('db_dir').config('pw_db')) || die $!;
    @pwd = <PWD>;
    close(PWD);

    foreach (@pwd) {
	if ($un) {
	    @line = split(/:/);
	    return $line[1];
	}
    }
}
sub own_entry {
    ($un, $sid, $p) = @_;
    $fp = $tinyCMS::db;
    if ($p) { 
	$fp = $p;
    }
    open(DB, $fp) || die $!;
    @db = <DB>;
    close(DB);

    for ($i = 0; $i <= $#db; $i++) {
	if ($db[$i] =~ /<Autor>: $un/) {
	    $db[$i+3] =~ s/<.*?>: //g;
	    if ($p) {
		$ret="<tr><td><a href=\"desktop.pl?mode=form&un=$un&sid=$sid&li=$i&st=pub\">".$db[$i+3]."</a></td><td><a href=erm.pl?line=".($i-1)."&sid=$sid&un=$un&file=$fp> Loeschen</td><td><a href=pub.pl?un=$un&sid=$sid&li=$i>Publish</a></td></tr>\n";
	    }
	    else {
		$ret="<tr><td><a href=\"desktop.pl?mode=form&un=$un&sid=$sid&li=$i\">".$db[$i+3]."</a></td><td><input type=checkbox name=line value=".($i-1)."> Loeschen</td></tr>\n";
	    }
	    push(@re, $ret);
	}
    }
    return @re;
}
sub sidgen {
    @time = (localtime(time()))[0..5];
    $ip = $ENV{'REMOTE_ADDR'};
    $key = rand(30000);
    foreach (@time) { $zeit .= $_; }
    $sid = crypt($zeit.$ip, $key);
    return $sid;
}
sub sidlog {
    @time = (localtime(time()))[0..5];
    ($sid, $user, $loc) = @_;
    open(LOGSID, ">>/home/ak/sidlog.txt") || die $!;
    print LOGSID "$sid:$time[3]-$time[4]-" ,$time[5]+1900, "-$time[2]-$time[1]-$time[0]:$un:$loc\n";
    close(LOGSID);
}
sub chkloggedsid {
    ($sid, $un) = @_;
    @lt = (localtime(time()))[0..5];
    $lt[5] += 1900;

    open(LOG, "/home/ak/sidlog.txt") || die $!;
    @log = <LOG>;
    close(LOG);

    foreach (@log) {
	if (/$sid/) {
	    @tmp = split(/:/);
	    if ($tmp[2] eq $un) {
		$ui = 1;
	    }
	    chomp($tmp[3]);
	    if ($tmp[3] eq 'login') {
		$li = 1;
	    }
	    if ($tmp[3] eq 'logout') {
		$li = 0;
	    }
	    @rt = split("-", $tmp[1]);
	}
    }
    if ($ui && $li) {
	if (($lt[5] == $rt[2]) && ($lt[4] == $rt[1]) && ($lt[3] == $rt[0])) {
	    if (($lt[2]-$rt[3]) <= 1) {
		$klgl = (($lt[2]-$rt[3]) == 1) ? 1 : 0;
		if (!$klgl) {
		    if ($lt[1] < $rt[4] && ($rt[4]-$lt[1]) <= 30) {
			$re = 1;
		    }
		    elsif ($lt[1] > $rt[4] && ($lt[1]-$rt[4]) <= 30) {
			$re = 1;
		    }
		    elsif ($lt[1] == $rt[4]) {
			$re = 1;
		    }
		    else {
			$re = "zeit";
		    }
		}
		elsif ($klgl) {
		    if ($rt[4] >= 30 && $lt[1] < 30) {
			if (($rt[4]-$lt[1]) <= 30) {
			    $re = 1;
			}
		    }
		    else {
			$re = "zeit";
		    }
		}
	    }
	    else {
		$re = "more than 1 hour";
	    }
	}
	else {
	    $re = "day does not match";
	}
    }
    else {
	$re = 0;
    }
    return $re;
}
sub readmesg {
    ($un) = shift;

    open(UMB, $tinyCMS::users.$un."/.messages") || die $!;
    @umb = <UMB>;
    close(UMB);

    $i = 0;
    while ($i <= $#umb) {
	if ($umb[$i] =~ /State: /) {
	    @tmphead = @umb[$i..$i+4];
	    $li = $i+1;
	    foreach (@tmphead) { s/^.*?: //g; }
	    $line = qq(
		       <a href=desktop.pl?mode=rmesg&un=$un&sid=$sid&li=$li>
		       $tmphead[4]
		       </a>
		       from $tmphead[2], $tmphead[3]<br>
		       );
	    push(@re, $line);
	    $i += 4;
	}
	else {
	    $i++;
	}
    }
    return @re;
}
sub showmesg {
    ($user, $line) = @_;

    open(MESG, $tinyCMS::users.$user."/.messages") || die $!;
    @news = <MESG>;
    close(MESG);

    $line -=1;
    while ($news[$line] =~ /^.*?: .*$/) {
	$mesg[$j] = $news[$line];
	$j++;
	$line++;
    }
    while (($news[$line] !~ /^.*?: .*$/) && ($line != $#news)) {
	$mesg[$j] = $news[$line];
	$j++;
	$line++;
    }
    return @mesg;
}

1;
